#include "wykres.h"

void wykres::changecentretarget()
{
  //if (sourcechange) delete sourcechange; // kasujemy, jeli jaki jest
  sourcechange=new QWidget();
  deltax=0;
  deltay=0;
  xvalue=new QLCDNumber(5,sourcechange);
  yvalue=new QLCDNumber(5,sourcechange);
  xchange=new QSlider(Qt::Horizontal,sourcechange);
  ychange=new QSlider(Qt::Horizontal,sourcechange);
  xchange->setRange(-200,200);
  ychange->setRange(-200,200);
  xchange->setValue(0);
  ychange->setValue(0);
  sourcelabel=new QLabel(tr("Changing centre of origin of target"),sourcechange);
  schangelayout=new QVBoxLayout(sourcechange);
  schangelayout->addWidget(sourcelabel);
  schangelayout->addWidget(xvalue);
  schangelayout->addWidget(xchange);
  schangelayout->addWidget(yvalue);
  schangelayout->addWidget(ychange);
  sourcechange->setLayout(schangelayout);
  connect(xchange,SIGNAL(valueChanged(int)),this,SLOT(changecentretargetrefreshx(int)));
  connect(ychange,SIGNAL(valueChanged(int)),this,SLOT(changecentretargetrefreshy(int)));
  connect(sourcechange,SIGNAL(destroyed()),this,SLOT(schangedestroyed()));
  connect(this,SIGNAL(changetargetx(double)),xvalue,SLOT(display(double)));
  connect(this,SIGNAL(changetargety(double)),yvalue,SLOT(display(double)));
  emit changetargetx(centretarget.re());
  emit changetargety(centretarget.im());

  sourcechange->show();
}
void wykres::schangedestroyed()
{
  centretarget2=centretarget;
}

void wykres::changecentretargetrefreshx(int w)
{
  deltax=rangetarget.re()*double(w)*0.01;
  centretarget=centretarget2+deltax+zespolone(0.0,1.0)*deltay;
  update();
  emit changetargetx(centretarget.re());
}

void wykres::changecentretargetrefreshy(int w)
{
  deltay=rangetarget.im()*double(w)*0.01;
  centretarget=centretarget2+deltax+zespolone(0.0,1.0)*deltay;
  update();
  emit changetargety(centretarget.im());
}

void wykres::moveinfinitytoorigin()
{
  if ((c.re()==0) && c.im()==0) return;
  centretarget=c.odwrot()*a;
  centretarget2=centretarget;
  deltax=0;
  deltay=0;
  update();
}

void wykres::changeellipsescale()
{
  //if (sourcechange) delete sourcechange; // kasujemy, jeli jaki jest
  scalechange=new QWidget();
  scalelcd=new QLCDNumber(5,scalechange);
  scaleslider=new QSlider(Qt::Horizontal,scalechange);
  scaleslider->setRange(-50,50);
  scaleslider->setValue(0);
  scalechangelabel=new QLabel(tr("Changing scales of ellipses"),scalechange);
  scalechangelay=new QVBoxLayout(scalechange);
  scalechangelay->addWidget(scalechangelabel);
  scalechangelay->addWidget(scalelcd);
  scalechangelay->addWidget(scaleslider);
  scalechange->setLayout(scalechangelay);
  connect(scaleslider,SIGNAL(valueChanged(int)),this,SLOT(ellipsescalechanged(int)));
  connect(scalechange,SIGNAL(destroyed()),this,SLOT(ellipsechangedestroyed()));
  connect(this,SIGNAL(changescaleell(double)),scalelcd,SLOT(display(double)));
  emit changescaleell(scaleellipse);
  update();

  scalechange->show();
}

void wykres::ellipsechangedestroyed()
{
  scaleellipse2=scaleellipse;
}

void wykres::ellipsescalechanged(int w)
{
  scaleellipse=expl(double(w)*0.02);
  update();
  emit changescaleell(scaleellipse);
}

void wykres::parameterchangedax(int w)
{
  dax=double(w)*0.02;
  a=a2+dax+zespolone(0.0,1.0)*day;
  update();
  emit changeax(a.re());
}
void wykres::parameterchangeday(int w)
{
  day=double(w)*0.02;
  a=a2+dax+zespolone(0.0,1.0)*day;
  update();
  emit changeay(a.im());
}
void wykres::parameterchangedbx(int w)
{
  dbx=double(w)*0.02;
  b=b2+dbx+zespolone(0.0,1.0)*dby;
  update();
  emit changebx(b.re());
}
void wykres::parameterchangedby(int w)
{
  dby=double(w)*0.02;
  b=b2+dbx+zespolone(0.0,1.0)*dby;
  update();
  emit changeby(b.im());
}
void wykres::parameterchangedcx(int w)
{
  dcx=double(w)*0.02;
  c=c2+dcx+zespolone(0.0,1.0)*dcy;
  update();
  emit changecx(c.re());
}
void wykres::parameterchangedcy(int w)
{
  dcy=double(w)*0.02;
  c=c2+dcx+zespolone(0.0,1.0)*dcy;
  update();
  emit changecy(c.im());
}
void wykres::parameterchangeddx(int w)
{
  ddx=double(w)*0.02;
  d=d2+ddx+zespolone(0.0,1.0)*ddy;
  update();
  emit changedx(d.re());
}

void wykres::parameterchangeddy(int w)
{
  ddy=double(w)*0.02;
  d=d2+ddx+zespolone(0.0,1.0)*ddy;
  update();
  emit changedy(d.im());
}

void wykres::parameterchangedestroyed()
{
  a2=a;
  b2=b;
  c2=c;
  d2=d;
}
void wykres::parameterchangestart()
{
  dax=0;day=0;dbx=0;dby=0;dcx=0;dcy=0;ddx=0;ddy=0;

  parameterchange=new QWidget();

  axslider=new QSlider(Qt::Horizontal,parameterchange);
  bxslider=new QSlider(Qt::Horizontal,parameterchange);
  cxslider=new QSlider(Qt::Horizontal,parameterchange);
  dxslider=new QSlider(Qt::Horizontal,parameterchange);
  ayslider=new QSlider(Qt::Horizontal,parameterchange);
  byslider=new QSlider(Qt::Horizontal,parameterchange);
  cyslider=new QSlider(Qt::Horizontal,parameterchange);
  dyslider=new QSlider(Qt::Horizontal,parameterchange);

  axslider->setRange(-200,200);
  axslider->setValue(0);
  ayslider->setRange(-200,200);
  ayslider->setValue(0);
  bxslider->setRange(-200,200);
  bxslider->setValue(0);
  byslider->setRange(-200,200);
  byslider->setValue(0);
  cxslider->setRange(-200,200);
  cxslider->setValue(0);
  cyslider->setRange(-200,200);
  cyslider->setValue(0);
  dxslider->setRange(-200,200);
  dxslider->setValue(0);
  dyslider->setRange(-200,200);
  dyslider->setValue(0);

  axlcd=new QLCDNumber(parameterchange);
  aylcd=new QLCDNumber(parameterchange);
  bxlcd=new QLCDNumber(parameterchange);
  bylcd=new QLCDNumber(parameterchange);
  cxlcd=new QLCDNumber(parameterchange);
  cylcd=new QLCDNumber(parameterchange);
  dxlcd=new QLCDNumber(parameterchange);
  dylcd=new QLCDNumber(parameterchange);

  parameterlabel=new QLabel(tr("Change parameters"),parameterchange);
  parameterlabela=new QLabel(tr("Change value of a"),parameterchange);
  parameterlabelb=new QLabel(tr("Change value of b"),parameterchange);
  parameterlabelc=new QLabel(tr("Change value of c"),parameterchange);
  parameterlabeld=new QLabel(tr("Change value of d"),parameterchange);
  parameterlabel->setFont(QFont("Helvetica",14));
  parameterlabela->setFont(QFont("Helvetica",14));
  parameterlabelb->setFont(QFont("Helvetica",14));
  parameterlabelc->setFont(QFont("Helvetica",14));
  parameterlabeld->setFont(QFont("Helvetica",14));

  paramchangelayout=new QGridLayout(parameterchange);
  paramchangelayout->addWidget(parameterlabel,0,0,1,3);
  paramchangelayout->addWidget(parameterlabela,1,0);
  paramchangelayout->addWidget(parameterlabelb,1,2);
  paramchangelayout->setColumnMinimumWidth(1,10);

  paramchangelayout->addWidget(axlcd,2,0);
  paramchangelayout->addWidget(axslider,3,0);
  paramchangelayout->addWidget(aylcd,4,0);
  paramchangelayout->addWidget(ayslider,5,0);

  paramchangelayout->addWidget(bxlcd,2,2);
  paramchangelayout->addWidget(bxslider,3,2);
  paramchangelayout->addWidget(bylcd,4,2);
  paramchangelayout->addWidget(byslider,5,2);

  paramchangelayout->setRowMinimumHeight(6,10);

  paramchangelayout->addWidget(parameterlabelc,7,0);
  paramchangelayout->addWidget(parameterlabeld,7,2);

  paramchangelayout->addWidget(cxlcd,8,0);
  paramchangelayout->addWidget(cxslider,9,0);
  paramchangelayout->addWidget(cylcd,10,0);
  paramchangelayout->addWidget(cyslider,11,0);

  paramchangelayout->addWidget(dxlcd,8,2);
  paramchangelayout->addWidget(dxslider,9,2);
  paramchangelayout->addWidget(dylcd,10,2);
  paramchangelayout->addWidget(dyslider,11,2);

  parameterchange->setLayout(paramchangelayout);

  connect(axslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangedax(int)));
  connect(ayslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangeday(int)));
  connect(bxslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangedbx(int)));
  connect(byslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangedby(int)));
  connect(cxslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangedcx(int)));
  connect(cyslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangedcy(int)));
  connect(dxslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangeddx(int)));
  connect(dyslider,SIGNAL(valueChanged(int)),this,SLOT(parameterchangeddy(int)));

  connect(parameterchange,SIGNAL(destroyed()),this,SLOT(parameterchangedestroyed()));

  connect(this,SIGNAL(changeax(double)),axlcd,SLOT(display(double)));
  connect(this,SIGNAL(changeay(double)),aylcd,SLOT(display(double)));
  connect(this,SIGNAL(changebx(double)),bxlcd,SLOT(display(double)));
  connect(this,SIGNAL(changeby(double)),bylcd,SLOT(display(double)));
  connect(this,SIGNAL(changecx(double)),cxlcd,SLOT(display(double)));
  connect(this,SIGNAL(changecy(double)),cylcd,SLOT(display(double)));
  connect(this,SIGNAL(changedx(double)),dxlcd,SLOT(display(double)));
  connect(this,SIGNAL(changedy(double)),dylcd,SLOT(display(double)));

  emit changeax(a.re());
  emit changeay(a.im());
  emit changebx(b.re());
  emit changeby(b.im());
  emit changecx(c.re());
  emit changecy(c.im());
  emit changedx(d.re());
  emit changecy(d.im());

  parameterchange->setMinimumWidth(500);
  parameterchange->show();
}
